<template>
  <div class="h-screen flex justify-center">
    <div
      class="background-login w-full md:w-full lg:w-1/2"
      :class="backgrounByTheme"
    >
      <div class="flex justify-between">
        <p
          class="py-2 pl-6 text-[var(--secondary)] text-base font-medium"
          :class="colorByTheme"
        >
          {{ $t("Register Page") }}
        </p>
        <utils-language class="px-6" />
      </div>
      <hr class="bg-border border-1" />
      <el-form class="px-3" :model="formModel">
        <div class="w-full p-3 mx-auto">
          <el-form
            ref="formRef"
            label-position="top"
            :model="formModel"
            :rules="formRules"
            :validate-on-rule-change="false"
            class="w-full mx-auto"
          >
            <el-form-item :label="$t('username')" prop="Username">
              <el-input
                v-model="formModel.Username"
                type="text"
                class="el-input-disabled"
              />
            </el-form-item>
            <el-form-item :label="$t('password')" prop="Password">
              <el-input
                v-model="formModel.Password"
                :placeholder="$t('password')"
                :type="inputTypePw"
              >
                <template #suffix>
                  <div @click.prevent="showPassword('password')">
                    <font-awesome-icon v-if="isShowPassword" icon="eye-slash" />
                    <font-awesome-icon v-else icon="eye" />
                  </div>
                </template>
              </el-input>
            </el-form-item>

            <el-form-item
              :label="$t('confirm_password')"
              prop="ConfirmPassword"
            >
              <el-input
                v-model="formModel.ConfirmPassword"
                :type="inputTypecfPw"
                :placeholder="$t('confirm_password')"
              >
                <template #suffix>
                  <div @click.prevent="showPassword('cfpassword')">
                    <font-awesome-icon
                      v-if="isShowcfPassword"
                      icon="eye-slash"
                    />
                    <font-awesome-icon v-else icon="eye" />
                  </div>
                </template>
              </el-input>
            </el-form-item>

            <el-form-item :label="$t('currency')" prop="Currency">
              <el-select
                v-model="formModel.Currency"
                filterable
                style="width: 100%"
                :disabled="currencies.length <= 0"
                class="register-selected-currency"
              >
                <el-option
                  v-for="currency in currencies"
                  :key="currency"
                  :value="String(currency.Currency)"
                >
                  <div class="flex justify-between w-full">
                    <div class="flex items-center">
                      <div>
                        {{ currency.Currency }}
                      </div>
                      <div class="w-[16px] ml-[11px] currency-check-icon">
                        <font-awesome-icon icon="circle-check" />
                      </div>
                    </div>
                  </div>
                </el-option>
              </el-select>
            </el-form-item>
            <template
              v-for="property in availableProperties"
              :key="property.PropertyName"
            >
              <el-form-item
                v-if="
                  property.PropertyName === 'Phone' &&
                  property.PropertyStatus === 'Required'
                "
                :label="property.PropertyNameForDisplay"
                :prop="property.PropertyName"
              >
                <el-input
                  v-model="formModel[property.PropertyName]"
                  class="el-input-disabled"
                />
              </el-form-item>
            </template>
            <template class="flex justify-center">
              <div class="mt-10">
                <el-button
                  type="success"
                  :disabled="isLoading"
                  :loading="isLoading"
                  round
                  class="px-4 py-1 text-sm w-full rounded btn"
                  :class="buttonColorByTheme"
                  @click="onTelegramRegister(formRef)"
                  >{{ $t("submit") }}</el-button
                >
              </div>
            </template>
          </el-form>
        </div>
      </el-form>
    </div>
  </div>
</template>
<script lang="ts">
import { defineComponent, computed } from "vue";
import { store } from "~~/store";
import useRegister from "@/composables/useRegister";

export default defineComponent({
  setup() {
    const themeName = store.state.selectedThemeName;
    const colorByTheme = computed(() => {
      if (themeName === "modern") {
        return "text-[var(--title-font-color)]";
      }
      if (themeName === "peru") {
        return "text-[var(--secondary)]";
      }
      return "text-login";
    });
    const backgrounByTheme = computed(() => {
      if (themeName === "playful") {
        return "bg-[var(--background2)]";
      }
      return "bg-[var(--background5)]";
    });
    const buttonColorByTheme = computed(() => {
      if (themeName === "sbo") {
        return "bg-primary";
      }
      return "bg-secondary";
    });

    const inputTypePw = ref("password");
    const inputTypecfPw = ref("password");
    const isShowPassword = ref(false);
    const isShowcfPassword = ref(false);
    const showPassword = (input: string) => {
      if (input === "password" && inputTypePw.value === "text") {
        inputTypePw.value = "password";
        isShowPassword.value = false;
      } else if (input === "password" && inputTypePw.value === "password") {
        inputTypePw.value = "text";
        isShowPassword.value = true;
      } else if (input === "cfpassword" && inputTypecfPw.value === "text") {
        inputTypecfPw.value = "password";
        isShowcfPassword.value = false;
      } else {
        inputTypecfPw.value = "text";
        isShowcfPassword.value = true;
      }
    };

    const {
      availableProperties,
      currencies,
      formModel,
      formRef,
      formRules,
      onTelegramRegister,
      isLoading,
      rules,
    } = useRegister();
    return {
      onTelegramRegister,
      isLoading,
      currencies,
      formModel,
      formRules,
      formRef,
      rules,
      themeName,
      colorByTheme,
      backgrounByTheme,
      buttonColorByTheme,
      isShowcfPassword,
      isShowPassword,
      inputTypePw,
      inputTypecfPw,
      showPassword,
      availableProperties,
    };
  },
});
</script>
<style lang="scss" scoped>
.svg-inline--fa {
  color: var(--text);
}
.selected {
  color: var(--hint) !important;
}
.selected .currency-check-icon {
  display: block;
}
.currency-check-icon {
  display: none;
}
.el-input-disabled {
  cursor: not-allowed;
  pointer-events: none;
}
</style>
